Package org.eclipse.m2m.atl.emftvm.impl

## Class RuleImpl.SuperRulesState

- java.lang.Object
- - org.eclipse.m2m.atl.emftvm.impl.RuleImpl.SuperRulesState

Direct Known Subclasses:
  `RuleImpl.WithoutSuperRulesState`, `RuleImpl.WithSuperRulesState`

Enclosing class:
  RuleImpl

    protected abstract class RuleImpl.SuperRulesState
    extends java.lang.Object

Base class for code that depends on whether the rule has any `Rule.getESuperRules()`.

### Constructor Summary

Constructors
`protected` `SuperRulesState()`

### Method Summary

All Methods Instance Methods Abstract Methods
`abstract void` `compileIterables​(ExecEnv env)` Compiles a list or map of iterables for each input rule element.
`abstract boolean` `match​(StackFrame frame)` Matches `#getRule()`.
`abstract boolean` `matchOne​(StackFrame frame)` Matches up to one match for `#getRule()`.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### SuperRulesState

    protected SuperRulesState()

### Method Detail

#### match

    public abstract boolean match​(StackFrame frame)

Matches `#getRule()`.

Parameters:
  `frame` - the stack frame in which to execute the matcher
Returns:
  `true` iff the rule has any matches

#### matchOne

    public abstract boolean matchOne​(StackFrame frame)

Matches up to one match for `#getRule()`.

Returns:
  `true` iff the rule has any matches

#### compileIterables

    public abstract void compileIterables​(ExecEnv env)

Compiles a list or map of iterables for each input rule element.

Parameters:
  `env` - the execution environment with models